2 # Based on the configure script from musl libc, MIT licensed
6 Usage: $0 [OPTION]... [VAR=VALUE]...
8 To assign environment variables (e.g., CC, CFLAGS...), specify them as
9 VAR=VALUE. See below for descriptions of some of the useful variables.
11 Defaults for the options are specified in brackets.
14 --srcdir=DIR source directory [detected]
16 Installation directories:
17 --prefix=PREFIX main installation prefix [/usr/local]
18 --exec-prefix=EPREFIX installation prefix for executable files [PREFIX]
20 Fine tuning of the installation directories:
21 --bindir=DIR user executables [EPREFIX/bin]
22 --sharedir=DIR share directories [PREFIX/share]
23 --docdir=DIR misc. documentation [PREFIX/share/doc]
24 --mandir=DIR man pages [PREFIX/share/man]
27 --enable-curses build with Curses terminal output [yes]
28 --enable-lua build with Lua support [auto]
29 --enable-lpeg-static build with LPeg static linking [auto]
30 --enable-tre build with TRE regex support [auto]
31 --enable-selinux build with SELinux support [auto]
32 --enable-acl build with POSIX ACL support [auto]
33 --enable-help build with built-in help texts [yes]
35 Some influential environment variables:
36 CC C compiler command [detected]
37 CFLAGS C compiler flags [-Os -pipe ...]
40 Use these variables to override the choices made by configure.
49 tr '\n' ' ' <<EOF | grep '^[-[:alnum:]_=,./:]* $' >/dev/null 2>&1 && { echo "$1" ; return 0 ; }
52 printf %s
\\n
"$1" |
sed -e "s/'/'\\\\''/g" -e "1s/^/'/" -e "\$s/\$/'/" -e "s#^'\([-[:alnum:]_,./:]*\)=\(.*\)\$#\1='\2#"
54 echo () { printf "%s\n" "$*" ; }
55 fail
() { echo "$*" ; exit 1 ; }
56 fnmatch
() { eval "case \"\$2\" in $1) return 0 ;; *) return 1 ;; esac" ; }
57 cmdexists
() { type "$1" >/dev
/null
2>&1 ; }
58 trycc
() { test -z "$CC" && cmdexists
"$1" && CC
=$1 ; }
61 while eval "fnmatch '*/' \"\${$1}\"" ; do eval "$1=\${$1%/}" ; done
65 printf "checking preprocessor condition %s... " "$1"
66 echo "typedef int x;" > "$tmpc"
67 echo "#if $1" >> "$tmpc"
68 echo "#error yes" >> "$tmpc"
69 echo "#endif" >> "$tmpc"
70 if $CC $2 -c -o "$tmpo" "$tmpc" >/dev
/null
2>&1 ; then
80 printf "checking whether compiler accepts %s... " "$2"
81 echo "typedef int x;" > "$tmpc"
82 if $CC $CFLAGS_TRY $2 -c -o "$tmpo" "$tmpc" >/dev
/null
2>&1 ; then
84 eval "$1=\"\${$1} \$2\""
94 printf "checking whether linker accepts %s... " "$2"
95 echo "typedef int x;" > "$tmpc"
96 if $CC $LDFLAGS_TRY -nostdlib -shared "$2" -o "$tmpo" "$tmpc" >/dev
/null
2>&1 ; then
98 eval "$1=\"\${$1} \$2\""
107 # Beginning of actual script
115 EXEC_PREFIX
='$(PREFIX)'
116 BINDIR
='$(EXEC_PREFIX)/bin'
117 SHAREDIR
='$(PREFIX)/share'
118 DOCDIR
='$(PREFIX)/share/doc'
119 MANDIR
='$(PREFIX)/share/man'
132 --srcdir=*) SRCDIR
=${arg#*=} ;;
133 --prefix=*) PREFIX
=${arg#*=} ;;
134 --exec-prefix=*) EXEC_PREFIX
=${arg#*=} ;;
135 --bindir=*) BINDIR
=${arg#*=} ;;
136 --sharedir=*) SHAREDIR
=${arg#*=} ;;
137 --docdir=*) DOCDIR
=${arg#*=} ;;
138 --mandir=*) MANDIR
=${arg#*=} ;;
139 --environment-only) environmentonly
=yes ;;
140 --enable-help|
--enable-help=yes) help=yes ;;
141 --disable-help|
--enable-help=no
) help=no
;;
142 --enable-curses|
--enable-curses=yes) curses
=yes ;;
143 --disable-curses|
--enable-curses=no
) curses
=no
;;
144 --enable-lua|
--enable-lua=yes) lua
=yes ;;
145 --disable-lua|
--enable-lua=no
) lua
=no
;;
146 --enable-lpeg-static|
--enable-lpeg-static=yes) lpeg
=yes ;;
147 --disable-lpeg-static|
--enable-lpeg-static=no
) lpeg
=no
;;
148 --enable-tre|
--enable-tre=yes) tre
=yes ;;
149 --disable-tre|
--enable-tre=no
) tre
=no
;;
150 --enable-selinux|
--enable-selinux=yes) selinux
=yes ;;
151 --disable-selinux|
--enable-selinux=no
) selinux
=no
;;
152 --enable-acl|
--enable-acl=yes) acl
=yes ;;
153 --disable-acl|
--enable-acl=no
) acl
=no
;;
154 --enable-*|
--disable-*|
--with-*|
--without-*|
--*dir
=*|
--build=*) ;;
155 -* ) echo "$0: unknown option $arg" ;;
156 CC
=*) CC
=${arg#*=} ;;
157 CFLAGS
=*) CFLAGS
=${arg#*=} ;;
158 CPPFLAGS
=*) CPPFLAGS
=${arg#*=} ;;
159 LDFLAGS
=*) LDFLAGS
=${arg#*=} ;;
165 for i
in SRCDIR PREFIX EXEC_PREFIX BINDIR SHAREDIR DOCDIR MANDIR
; do
170 # Get the source dir for out-of-tree builds
172 if test -z "$SRCDIR" ; then
173 SRCDIR
="${0%/configure}"
176 abs_builddir
="$(pwd)" || fail
"$0: cannot determine working directory"
177 abs_srcdir
="$(cd $SRCDIR && pwd)" || fail
"$0: invalid source directory $SRCDIR"
178 test "$abs_srcdir" = "$abs_builddir" && SRCDIR
=.
179 test "$SRCDIR" != "." -a -f Makefile
-a ! -h Makefile
&& fail
"$0: Makefile already exists in the working directory"
182 # Get a temp filename we can use
186 while : ; do i
=$
(($i+1))
187 tmpc
="./conf$$-$PPID-$i.c"
188 tmpo
="./conf$$-$PPID-$i.o"
189 2>|
/dev
/null
> "$tmpc" && break
190 test "$i" -gt 50 && fail
"$0: cannot create temporary file $tmpc"
193 trap 'rm -f "$tmpc" "$tmpo"' EXIT QUIT TERM HUP
194 trap 'rm -f "$tmpc" "$tmpo" && echo && fail "$0: interrupted"' INT
197 # Find a C compiler to use
199 printf "checking for C compiler... "
204 test -n "$CC" ||
{ echo "$0: cannot find a C compiler" ; exit 1 ; }
206 printf "checking whether C compiler works... "
207 echo "typedef int x;" > "$tmpc"
208 if output
=$
($CC $CPPFLAGS $CFLAGS -c -o "$tmpo" "$tmpc" 2>&1) ; then
211 printf "no; compiler output follows:\n%s\n" "$output"
216 # Figure out options to force errors on unknown flags.
218 tryflag CFLAGS_TRY
-Werror=unknown-warning-option
219 tryflag CFLAGS_TRY
-Werror=unused-command-line-argument
220 tryldflag LDFLAGS_TRY
-Werror=unknown-warning-option
221 tryldflag LDFLAGS_TRY
-Werror=unused-command-line-argument
223 CFLAGS_STD
="-std=c99 -D_POSIX_C_SOURCE=200809L -D_XOPEN_SOURCE=700 -DNDEBUG -D_FORTIFY_SOURCE=2"
229 FreeBSD|DragonFly
) CFLAGS_STD
="$CFLAGS_STD -D_BSD_SOURCE -D__BSD_VISIBLE=1" ;;
230 *BSD
) CFLAGS_STD
="$CFLAGS_STD -D_BSD_SOURCE" ;;
231 Darwin
) CFLAGS_STD
="$CFLAGS_STD -D_DARWIN_C_SOURCE" ;;
232 AIX
) CFLAGS_STD
="$CFLAGS_STD -D_ALL_SOURCE" ;;
237 # Try flags to optimize binary size
239 tryflag CFLAGS
-ffunction-sections
240 tryflag CFLAGS
-fdata-sections
241 tryldflag LDFLAGS_AUTO
-Wl,--gc-sections
243 # Try hardening flags
245 tryflag CFLAGS_AUTO
-fstack-protector-all
246 tryldflag LDFLAGS
-Wl,-z,now
247 tryldflag LDFLAGS
-Wl,-z,relro
248 tryldflag LDFLAGS_AUTO
-pie
250 printf "creating config.mk... "
252 cmdline
=$
(quote
"$0")
253 for i
; do cmdline
="$cmdline $(quote "$i")" ; done
255 exec 3>&1 1>config.mk
258 # This version of config.mk was generated by:
260 # Any changes made here will be lost if configure is re-run
263 EXEC_PREFIX = $EXEC_PREFIX
267 SHAREPREFIX = $SHAREDIR
271 CFLAGS_STD = $CFLAGS_STD
272 LDFLAGS_STD = $LDFLAGS_STD
273 CFLAGS_AUTO = $CFLAGS_AUTO
274 LDFLAGS_AUTO = $LDFLAGS_AUTO
275 CFLAGS_DEBUG = -U_FORTIFY_SOURCE -UNDEBUG -O0 -g3 -ggdb -Wall -Wextra -pedantic -Wno-missing-field-initializers -Wno-unused-parameter
281 if test "$environmentonly" = "yes"; then
286 printf "checking for pkg-config... "
287 cmdexists pkg-config
&& have_pkgconfig
=yes
288 printf "%s\n" "$have_pkgconfig"
290 if test "$help" = "yes" ; then
298 if test "$curses" != "no" ; then
300 printf "checking for libcurses...\n"
305 int main(int argc, char *argv[]) {
312 for libcurses
in ncursesw ncurses libcurses
; do
313 printf " checking for %s... " "$libcurses"
315 if test "$have_pkgconfig" = "yes" ; then
316 CFLAGS_CURSES
=$
(pkg-config
--cflags $libcurses 2>/dev
/null
)
317 LDFLAGS_CURSES
=$
(pkg-config
--libs $libcurses 2>/dev
/null
)
318 if test $?
-eq 0 && $CC $CFLAGS $CFLAGS_CURSES "$tmpc" \
319 $LDFLAGS $LDFLAGS_CURSES -o "$tmpo" >/dev
/null
2>&1 ; then
327 LDFLAGS_CURSES
="-l$libcurses"
329 if $CC $CFLAGS $CFLAGS_CURSES "$tmpc" \
330 $LDFLAGS $LDFLAGS_CURSES -o "$tmpo" >/dev
/null
2>&1 ; then
341 test "$curses" = "yes" -a $CONFIG_CURSES -ne 1 && fail
"$0: cannot find libcurses"
344 # libtermkey is a mandatory dependency
346 printf "checking for libtermkey... "
350 int main(int argc, char *argv[]) {
351 TERMKEY_CHECK_VERSION;
356 if test "$have_pkgconfig" = "yes" ; then
357 CFLAGS_TERMKEY
=$
(pkg-config
--cflags termkey
2>/dev
/null
)
358 LDFLAGS_TERMKEY
=$
(pkg-config
--libs termkey
2>/dev
/null
)
361 if test -z "$LDFLAGS_TERMKEY"; then
363 LDFLAGS_TERMKEY
="-ltermkey"
366 if $CC $CFLAGS $CFLAGS_TERMKEY "$tmpc" $LDFLAGS $LDFLAGS_TERMKEY $LDFLAGS_CURSES \
367 -o "$tmpo" >/dev
/null
2>&1; then
371 fail
"$0: cannot find libtermkey"
375 REGEX_SRC
=text-regex.c
377 if test "$tre" != "no" ; then
379 printf "checking for libtre... "
386 tre_str_source *source = NULL;
387 regmatch_t pmatch[1];
388 tre_regcomp(&preg, "\0", REG_EXTENDED);
389 tre_reguexec(&preg, source, 1, pmatch, 0);
395 if test "$have_pkgconfig" = "yes" ; then
396 CFLAGS_TRE
=$
(pkg-config
--cflags tre
2>/dev
/null
)
397 LDFLAGS_TRE
=$
(pkg-config
--libs tre
2>/dev
/null
)
400 if test -z "$LDFLAGS_TRE"; then
405 if $CC $CFLAGS $CFLAGS_TRE "$tmpc" \
406 $LDFLAGS $LDFLAGS_TRE -o "$tmpo" >/dev
/null
2>&1; then
408 REGEX_SRC
=text-regex-tre.c
414 test "$tre" = "yes" && fail
"$0: cannot find libtre"
420 # enabling builtin lpeg requires lua support
421 test "$lpeg" = "yes" -a "$lua" = "no" && fail
"$0: need lua support for built-in lpeg"
422 test "$lpeg" = "yes" && lua
=yes
424 if test "$lua" != "no" ; then
426 printf "checking for liblua >= 5.2 ...\n"
433 #if LUA_VERSION_NUM < 502
434 #error "Need at least Lua 5.2"
437 int main(int argc, char *argv[]) {
438 lua_State *L = luaL_newstate();
445 for liblua
in lua lua5.3 lua5.2 lua-5.3 lua-5.2 lua53 lua52
; do
446 printf " checking for %s... " "$liblua"
448 if test "$have_pkgconfig" = "yes" ; then
449 CFLAGS_LUA
=$
(pkg-config
--cflags $liblua 2>/dev
/null
)
450 LDFLAGS_LUA
=$
(pkg-config
--libs $liblua 2>/dev
/null
)
451 if test $?
-eq 0 && $CC $CFLAGS $CFLAGS_LUA "$tmpc" \
452 $LDFLAGS $LDFLAGS_LUA -o "$tmpo" >/dev
/null
2>&1 ; then
460 LDFLAGS_LUA
="-l$liblua -lm -ldl"
462 if $CC $CFLAGS $CFLAGS_LUA "$tmpc" \
463 $LDFLAGS $LDFLAGS_LUA -o "$tmpo" >/dev
/null
2>&1 ; then
474 test "$lua" = "yes" -a $CONFIG_LUA -ne 1 && fail
"$0: cannot find liblua"
476 if test $CONFIG_LUA -eq 1; then
477 CFLAGS_LUA
="$CFLAGS_LUA -DLUA_COMPAT_5_1 -DLUA_COMPAT_5_2 -DLUA_COMPAT_ALL"
483 if test $CONFIG_LUA -eq 1 -a "$lpeg" != "no" ; then
485 printf "checking for Lua statically linked liblpeg...\n"
492 int main(int argc, char *argv[]) {
493 lua_State *L = luaL_newstate();
495 extern int luaopen_lpeg(lua_State *L);
496 lua_getglobal(L, "package");
497 lua_getfield(L, -1, "preload");
498 lua_pushcfunction(L, luaopen_lpeg);
499 lua_setfield(L, -2, "lpeg");
506 for liblpeg
in lpeg lua5.3
-lpeg lua5.2
-lpeg; do
507 printf " checking for static %s... " "$liblpeg"
509 if test "$have_pkgconfig" = "yes" ; then
510 CFLAGS_LPEG
=$
(pkg-config
--cflags $liblpeg 2>/dev
/null
)
511 LDFLAGS_LPEG
=$
(pkg-config
--libs $liblpeg 2>/dev
/null
)
512 if test $?
-eq 0 && $CC $CFLAGS $CFLAGS_LUA $CFLAGS_LPEG "$tmpc" \
513 $LDFLAGS $LDFLAGS_LUA $LDFLAGS_LPEG -o "$tmpo" >/dev
/null
2>&1 ; then
521 LDFLAGS_LPEG
="-l$liblpeg"
523 if $CC $CFLAGS $CFLAGS_LUA $CFLAGS_LPEG "$tmpc" \
524 $LDFLAGS $LDFLAGS_LUA $LDFLAGS_LPEG -o "$tmpo" >/dev
/null
2>&1 ; then
535 test "$lpeg" = "yes" -a $CONFIG_LPEG -ne 1 && fail
"$0: cannot find liblpeg"
540 if test "$OS" = "Linux" -a "$acl" != "no"; then
541 printf "checking for libacl... "
544 #include <sys/types.h>
547 int main(int argc, char *argv[]) {
548 acl_t acl = acl_get_fd(0);
553 if test "$have_pkgconfig" = "yes" ; then
554 CFLAGS_ACL
=$
(pkg-config
--cflags acl
2>/dev
/null
)
555 LDFLAGS_ACL
=$
(pkg-config
--libs acl
2>/dev
/null
)
558 if test -z "$LDFLAGS_ACL"; then
563 if $CC $CFLAGS $CFLAGS_ACL "$tmpc" \
564 $LDFLAGS $LDFLAGS_ACL -o "$tmpo" >/dev
/null
2>&1; then
571 test "$acl" = "yes" && fail
"$0: cannot find libacl"
577 if test "$OS" = "Linux" -a "$selinux" != "no"; then
578 printf "checking for libselinux... "
581 #include <selinux/selinux.h>
583 int main(int argc, char *argv[]) {
584 return is_selinux_enabled();
588 if test "$have_pkgconfig" = "yes" ; then
589 CFLAGS_SELINUX
=$
(pkg-config
--cflags selinux
2>/dev
/null
)
590 LDFLAGS_SELINUX
=$
(pkg-config
--libs selinux
2>/dev
/null
)
593 if test -z "$LDFLAGS_SELINUX"; then
595 LDFLAGS_SELINUX
="-lselinux"
598 if $CC $CFLAGS $CFLAGS_SELINUX "$tmpc" \
599 $LDFLAGS $LDFLAGS_SELINUX -o "$tmpo" >/dev
/null
2>&1; then
606 test "$selinux" = "yes" && fail
"$0: cannot find libselinux"
610 printf "checking for memrchr... "
616 int main(int argc, char *argv[]) {
617 return !memrchr("\n", '\n', 1);
621 if $CC $CFLAGS "$tmpc" $LDFLAGS -o "$tmpo" >/dev
/null
2>&1; then
629 printf "completing config.mk... "
631 exec 3>&1 1>>config.mk
634 CONFIG_HELP = $CONFIG_HELP
635 CFLAGS_TERMKEY = $CFLAGS_TERMKEY
636 LDFLAGS_TERMKEY = $LDFLAGS_TERMKEY
637 CONFIG_CURSES = $CONFIG_CURSES
638 CFLAGS_CURSES = $CFLAGS_CURSES
639 LDFLAGS_CURSES = $LDFLAGS_CURSES
640 REGEX_SRC = $REGEX_SRC
641 CONFIG_TRE = $CONFIG_TRE
642 CFLAGS_TRE = $CFLAGS_TRE
643 LDFLAGS_TRE = $LDFLAGS_TRE
644 CONFIG_LUA = $CONFIG_LUA
645 CFLAGS_LUA = $CFLAGS_LUA
646 LDFLAGS_LUA = $LDFLAGS_LUA
647 CONFIG_LPEG = $CONFIG_LPEG
648 CFLAGS_LPEG = $CFLAGS_LPEG
649 LDFLAGS_LPEG = $LDFLAGS_LPEG
650 CONFIG_ACL = $CONFIG_ACL
651 CFLAGS_ACL = $CFLAGS_ACL
652 LDFLAGS_ACL = $LDFLAGS_ACL
653 CONFIG_SELINUX = $CONFIG_SELINUX
654 CFLAGS_SELINUX = $CFLAGS_SELINUX
655 LDFLAGS_SELINUX = $LDFLAGS_SELINUX
656 CFLAGS_LIBC = -DHAVE_MEMRCHR=$HAVE_MEMRCHR
660 test "$SRCDIR" = "." ||
ln -sf $SRCDIR/Makefile .